require '_h2ph_pre.ph';

unless(defined(&__ASM_I386_I387_H)) {
    eval 'sub __ASM_I386_I387_H () {1;}' unless defined(&__ASM_I386_I387_H);
    if(defined(&CONFIG_X86_FX)) {
	eval 'sub i387_save_hard {
	    local($x) = @_;
    	    eval q( &do {  &if ( ($boot_cpu_data->{x86_capability}) &  &X86_FEATURE_FXSR) {  &__asm__  &__volatile__(\\"fxsave %0\\" : \\"=m\\" (($x). ($hard->{fxsave}->{fxcwd}))); }  &else {  &__asm__  &__volatile__(\\"fnsave %0; fwait;\\" : \\"=m\\" (($x). ($hard->{fsave}->{cwd}))); } }  &while(0));
	}' unless defined(&i387_save_hard);
	eval 'sub i387_restore_hard {
	    local($x) = @_;
    	    eval q( &do {  &if ( ($boot_cpu_data->{x86_capability}) &  &X86_FEATURE_FXSR) {  &__asm__  &__volatile__(\\"fxrstor %0\\" : : \\"m\\" (($x). ($hard->{fxsave}->{fxcwd}))); }  &else {  &__asm__  &__volatile__(\\"frstor %0\\" : :\\"m\\" (($x). ($hard->{fsave}->{cwd}))); } }  &while(0));
	}' unless defined(&i387_restore_hard);
	eval 'sub i387_set_cwd {
	    local($x,$v) = @_;
    	    eval q( &do {  &if ( ($boot_cpu_data->{x86_capability}) &  &X86_FEATURE_FXSR) { . ($fxsave->{fxcwd}) = ; }  &else { . ($fsave->{cwd}) = (($v) | 0xffff0000); } }  &while(0));
	}' unless defined(&i387_set_cwd);
	eval 'sub i387_set_swd {
	    local($x,$v) = @_;
    	    eval q( &do {  &if ( ($boot_cpu_data->{x86_capability}) &  &X86_FEATURE_FXSR) { . ($fxsave->{fxswd}) = ; }  &else { . ($fsave->{swd}) = (($v) | 0xffff0000); } }  &while(0));
	}' unless defined(&i387_set_swd);
	eval 'sub i387_set_twd {
	    local($x,$v) = @_;
    	    eval q( &do {  &if ( ($boot_cpu_data->{x86_capability}) &  &X86_FEATURE_FXSR) { . ($fxsave->{fxtwd}) = ; }  &else { . ($fsave->{twd}) = (($v) | 0xffff0000); } }  &while(0));
	}' unless defined(&i387_set_twd);
    } else {
	eval 'sub i387_save_hard {
	    local($x) = @_;
    	    eval q( &do {  &__asm__  &__volatile__(\\"fnsave %0; fwait;\\" : \\"=m\\" (($x). ($hard->{fsave}->{cwd}))); }  &while(0));
	}' unless defined(&i387_save_hard);
	eval 'sub i387_restore_hard {
	    local($x) = @_;
    	    eval q( &do {  &__asm__  &__volatile__(\\"frstor %0\\" : :\\"m\\" (($x). ($hard->{fsave}->{cwd}))); }  &while(0));
	}' unless defined(&i387_restore_hard);
	eval 'sub i387_set_cwd {
	    local($x,$v) = @_;
    	    eval q( &do { . ($fsave->{cwd}) = (($v) | 0xffff0000); }  &while(0));
	}' unless defined(&i387_set_cwd);
	eval 'sub i387_set_swd {
	    local($x,$v) = @_;
    	    eval q( &do { . ($fsave->{swd}) = (($v) | 0xffff0000); }  &while(0));
	}' unless defined(&i387_set_swd);
	eval 'sub i387_set_twd {
	    local($x,$v) = @_;
    	    eval q( &do { . ($fsave->{twd}) = (($v) | 0xffff0000); }  &while(0));
	}' unless defined(&i387_set_twd);
    }
    eval 'sub save_kern_fpu {
        local($tsk) = @_;
	    eval q( &do {  &if( ($tsk->{tss}->{mmx_reg_space}) !=  &NULL)  &__asm__(\\"movq %%mm0, 0x00(%0)\\\\n\\\\t\\" \\"movq %%mm1, 0x08(%0)\\\\n\\\\t\\" \\"movq %%mm2, 0x10(%0)\\\\n\\\\t\\" \\"movq %%mm3, 0x18(%0)\\\\n\\\\t\\" :: \\"r\\" ( ($tsk->{tss}->{mmx_reg_space})):\\"memory\\");  &if( ($tsk->{tss}->{kni_reg_space}) !=  &NULL)  &__asm__(\\"movups %%xmm0, 0x00(%0)\\\\n\\\\t\\" \\"movups %%xmm1, 0x10(%0)\\\\n\\\\t\\" \\"movups %%xmm2, 0x20(%0)\\\\n\\\\t\\" \\"movups %%xmm3, 0x30(%0)\\\\n\\\\t\\" :: \\"r\\" ( ($tsk->{tss}->{kni_reg_space})):\\"memory\\"); }  &while (0));
    }' unless defined(&save_kern_fpu);
    eval 'sub unlazy_fpu {
        local($tsk) = @_;
	    eval q( &do {  &if ( ($tsk->{tss}->{x86_fpustate}) &  &X86_FPUSTATE_KERN_ANY) {  &save_kern_fpu($tsk);  &if (!( ($tsk->{flags}) &  &PF_USEDFPU)) {  &stts(); } }  &if ( ($tsk->{flags}) &  &PF_USEDFPU) {  &if (!( ($tsk->{tss}->{x86_fpustate}) &  &X86_FPUSTATE_USER_SAVED)) {  &i387_save_hard( ($tsk->{tss}->{i387})); }  ($tsk->{flags}) &= ~ &PF_USEDFPU;  &stts(); } }  &while (0));
    }' unless defined(&unlazy_fpu);
    eval 'sub clear_fpu {
        local($tsk) = @_;
	    eval q( &do {  &if ( ( ($tsk->{flags}) &  &PF_USEDFPU) || ( ($tsk->{tss}->{x86_fpustate})) ) {  ($tsk->{flags}) &= ~ &PF_USEDFPU;  ($tsk->{tss}->{x86_fpustate}) = 0;  &stts(); } }  &while (0));
    }' unless defined(&clear_fpu);
    eval 'sub SAVE_MMX_REGS {
        local($regs) = @_;
	    eval q( &__asm__  &__volatile__(\\"movq %%mm0, 0x00(%0)\\\\n\\\\t\\" \\"movq %%mm1, 0x08(%0)\\\\n\\\\t\\" \\"movq %%mm2, 0x10(%0)\\\\n\\\\t\\" \\"movq %%mm3, 0x18(%0)\\\\n\\\\t\\" : : \\"r\\" (($regs)) : \\"memory\\" ););
    }' unless defined(&SAVE_MMX_REGS);
    eval 'sub RESTORE_MMX_REGS {
        local($regs) = @_;
	    eval q( &__asm__  &__volatile__(\\"movq 0x00(%0), %%mm0\\\\n\\\\t\\" \\"movq 0x08(%0), %%mm1\\\\n\\\\t\\" \\"movq 0x10(%0), %%mm2\\\\n\\\\t\\" \\"movq 0x18(%0), %%mm3\\\\n\\\\t\\" : : \\"r\\" (($regs))););
    }' unless defined(&RESTORE_MMX_REGS);
    eval 'sub SAVE_KNI_REGS {
        local($regs) = @_;
	    eval q( &__asm__  &__volatile__(\\"movups %%xmm0, 0x00(%0)\\\\n\\\\t\\" \\"movups %%xmm1, 0x10(%0)\\\\n\\\\t\\" \\"movups %%xmm2, 0x20(%0)\\\\n\\\\t\\" \\"movups %%xmm3, 0x30(%0)\\\\n\\\\t\\" : : \\"r\\" (($regs)) : \\"memory\\" ););
    }' unless defined(&SAVE_KNI_REGS);
    eval 'sub RESTORE_KNI_REGS {
        local($regs) = @_;
	    eval q( &__asm__  &__volatile__(\\"movups 0x00(%0), %%xmm0\\\\n\\\\t\\" \\"movups 0x10(%0), %%xmm1\\\\n\\\\t\\" \\"movups 0x20(%0), %%xmm2\\\\n\\\\t\\" \\"movups 0x30(%0), %%xmm3\\\\n\\\\t\\" : : \\"r\\" (($regs))););
    }' unless defined(&RESTORE_KNI_REGS);
    eval 'sub SFENCE () {
        eval q( &__asm__  &__volatile__(\\"sfence\\":::\\"memory\\"));
    }' unless defined(&SFENCE);
    eval 'sub kernel_take_fpu_mmx {
        local($recursive, $regs, $task_switch_regs, $irqflags) = @_;
	    eval q( &do {  &spin_lock_irqsave( &kern_fpu_lock, ($irqflags));  &clts(); ($recursive) = ( ($current->{tss}->{x86_fpustate}) &  &X86_FPUSTATE_KERN_ANY);  &if ( ( ($current->{flags}) &  &PF_USEDFPU)  && !( ($current->{tss}->{x86_fpustate}) &  &X86_FPUSTATE_USER_SAVED) ){  &i387_save_hard( ($current->{tss}->{i387}));  ($current->{tss}->{x86_fpustate}) |=  &X86_FPUSTATE_USER_SAVED; }  &if (($recursive) &  &X86_FPUSTATE_KERN_MMX) {  &SAVE_MMX_REGS(($regs)); }  &else {  ($current->{tss}->{mmx_reg_space}) = ($task_switch_regs);  ($current->{tss}->{x86_fpustate}) |=  &X86_FPUSTATE_KERN_MMX; }  &spin_unlock_irqrestore( &kern_fpu_lock, ($irqflags)); }  &while (0));
    }' unless defined(&kernel_take_fpu_mmx);
    eval 'sub kernel_release_fpu_mmx {
        local($recursive, $regs, $irqflags) = @_;
	    eval q( &do {  &spin_lock_irqsave( &kern_fpu_lock, ($irqflags));  &if (($recursive) &  &X86_FPUSTATE_KERN_MMX) {  &RESTORE_MMX_REGS(($regs)); }  &else {  ($current->{tss}->{x86_fpustate}) &= ~ &X86_FPUSTATE_KERN_MMX;  ($current->{tss}->{mmx_reg_space}) =  &NULL; }  &if (($recursive) == 0) {  &stts(); }  &spin_unlock_irqrestore( &kern_fpu_lock, ($irqflags)); }  &while (0));
    }' unless defined(&kernel_release_fpu_mmx);
    eval 'sub kernel_take_fpu_kni {
        local($recursive, $regs, $task_switch_regs, $irqflags) = @_;
	    eval q( &do {  &spin_lock_irqsave( &kern_fpu_lock, ($irqflags));  &clts(); ($recursive) =  ($current->{tss}->{x86_fpustate});  &if ( ( ($current->{flags}) &  &PF_USEDFPU) || ( ($current->{tss}->{x86_fpustate}) &  &X86_FPUSTATE_KERN_KNI) ) {  &SAVE_KNI_REGS(($regs)); }  &if (!( ($current->{tss}->{x86_fpustate}) &  &X86_FPUSTATE_KERN_KNI)) {  ($current->{tss}->{kni_reg_space}) = ($task_switch_regs);  ($current->{tss}->{x86_fpustate}) |=  &X86_FPUSTATE_KERN_KNI; }  &spin_unlock_irqrestore( &kern_fpu_lock, ($irqflags)); }  &while (0));
    }' unless defined(&kernel_take_fpu_kni);
    eval 'sub kernel_release_fpu_kni {
        local($recursive, $regs, $irqflags) = @_;
	    eval q( &do {  &spin_lock_irqsave( &kern_fpu_lock, ($irqflags));  &if ( ( ($current->{tss}->{x86_fpustate}) &  &X86_FPUSTATE_USER_SAVED)  && !((($recursive) &  &X86_FPUSTATE_USER_SAVED)  && ( ($current->{flags}) &  &PF_USEDFPU)) ) {  &i387_restore_hard( ($current->{tss}->{i387}));  ($current->{tss}->{x86_fpustate}) &= ~ &X86_FPUSTATE_USER_SAVED; }  &if ( (($recursive) &  &X86_FPUSTATE_KERN_KNI) || ( ($current->{flags}) &  &PF_USEDFPU) ) {  &RESTORE_KNI_REGS(($regs)); }  &if ((($recursive) &  &X86_FPUSTATE_KERN_KNI) == 0) {  ($current->{tss}->{x86_fpustate}) &= ~ &X86_FPUSTATE_KERN_KNI;  ($current->{tss}->{kni_reg_space}) =  &NULL; }  &if ( (($recursive) == 0)  && (( ($current->{flags}) &  &PF_USEDFPU) == 0) ) {  &stts(); }  &spin_unlock_irqrestore( &kern_fpu_lock, ($irqflags)); }  &while (0));
    }' unless defined(&kernel_release_fpu_kni);
}
1;
